<template>
  <div class="">
    <div id="app">
      <slot />
      <div class="popup-report" v-if="modal">
        <div class="test bg-red">
          <validation-observer v-slot="{ handleSubmit }">
            <form class="card" @submit.prevent="handleSubmit(doCreateReport)">
              <div class="card pt-2 pb-2 pl-2">
                <h3>Create Report</h3>
              </div>
              <div class="card-body pr-5 pl-5 pt-5 pb-5">
                <div class="mb-3">
                  <div class="row g-3 align-items-center">
                    <div class="col-6 pr-8">
                      <div class="row">
                        <div class="col-2">
                          <label for="inputEmail3" class="col-form-label"
                            >Work</label
                          >
                        </div>
                        <div class="col-10 pl-0">
                          <div class="input-group col-11">
                            <validation-provider
                              name="Work"
                              rules="required|max:255|min:2"
                              v-slot="{ errors }"
                              class="w-100"
                            >
                              <textarea
                                type="text"
                                class="form-control"
                                id="inlineFormInputGroupUsername"
                                placeholder="Work"
                                v-model="report.work"
                              >
                              </textarea>
                              <span class="d-flex" style="color: red">{{
                                errors[0]
                              }}</span>
                            </validation-provider>
                          </div>
                        </div>
                      </div>
                    </div>
                    <div class="col-6">
                      <div class="row mb-6">
                        <div class="col-2">
                          <label for="inputEmail3" class="col-form-label"
                            >Difficult</label
                          >
                        </div>
                        <div class="col-10 pl-0">
                          <div class="input-group col-11">
                            <validation-provider
                              name="Difficult"
                              rules="required|max:255|min:2"
                              v-slot="{ errors }"
                              class="w-100"
                            >
                              <textarea
                                type="text"
                                class="form-control"
                                id="inlineFormInputGroupUsername"
                                placeholder="Difficult"
                                v-model="report.difficult"
                              ></textarea>
                              <span class="d-flex" style="color: red">{{
                                errors[0]
                              }}</span>
                            </validation-provider>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="mb-3">
                  <div class="row g-3 align-items-center">
                    <div class="col-6">
                      <div class="row mb-6">
                        <div class="col-2">
                          <label for="inputEmail3" class="col-form-label"
                            >Experience</label
                          >
                        </div>
                        <div class="col-10 pl-0">
                          <div class="input-group col-11">
                            <validation-provider
                              name="Experience"
                              rules="required|max:255|min:2"
                              v-slot="{ errors }"
                              class="w-100"
                            >
                              <textarea
                                type="text"
                                class="form-control"
                                id="inlineFormInputGroupUsername"
                                placeholder="Experience"
                                v-model="report.experience"
                              />
                              <span class="d-flex" style="color: red">{{
                                errors[0]
                              }}</span>
                            </validation-provider>
                          </div>
                        </div>
                      </div>
                    </div>
                    <div class="col-6">
                      <div class="row mb-6">
                        <div class="col-2">
                          <label for="inputEmail3" class="col-form-label"
                            >Suggest</label
                          >
                        </div>
                        <div class="col-10 pl-0">
                          <div class="input-group col-11">
                            <validation-provider
                              name="Suggest"
                              rules="required|max:255|min:2"
                              v-slot="{ errors }"
                              class="w-100"
                            >
                              <textarea
                                type="text"
                                class="form-control"
                                id="inlineFormInputGroupUsername"
                                placeholder="Suggest"
                                v-model="report.suggest"
                              />
                              <span class="d-flex" style="color: red">{{
                                errors[0]
                              }}</span>
                            </validation-provider>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="mb-3">
                  <div class="row g-3 align-items-center">
                    <div class="col-6">
                      <div class="row mb-6">
                        <div class="col-2">
                          <label for="inputEmail3" class="col-form-label"
                            >Day Report</label
                          >
                        </div>
                        <div class="col-10 pl-0">
                          <div class="input-group col-11">
                            <validation-provider
                              name="Day Report"
                              rules="required"
                              v-slot="{ errors }"
                              class="w-100"
                            >
                              <input
                                type="date"
                                class="form-control"
                                id="inlineFormInputGroupUsername"
                                v-model="report.report_day"
                              />
                              <span class="d-flex" style="color: red">{{
                                errors[0]
                              }}</span>
                            </validation-provider>
                          </div>
                        </div>
                      </div>
                    </div>
                    <div class="col-6">
                      <div class="row mb-6">
                        <div class="col-2">
                          <label for="inputEmail3" class="col-form-label"
                            >Team</label
                          >
                        </div>
                        <div class="col-10 pl-0">
                          <div class="input-group col-11">
                            <select
                              class="form-select"
                              id="inlineFormSelectPref"
                              v-model="report.team"
                            >
                              <option
                                type="hidden"
                                v-for="(item, idx) in teamList"
                                :key="idx"
                                :value="item.id"
                              >
                                {{ item.name }}
                              </option>
                            </select>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div
                class="form-submit card-footer text-center pt-3 pb-3"
                id="btn-bottom"
              >
                <button type="submit" class="btn btn-success">
                  <font-awesome-icon fas icon="save" />
                  Save
                </button>
                <button
                  type="button"
                  class="btn btn-primary"
                  @click="closeModal()"
                >
                  <font-awesome-icon fas icon="window-close" />
                  Close
                </button>
              </div>
            </form>
          </validation-observer>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { API_REPORT, API_USER, BASE_API } from '~/assets/contants/contant.js'

export default {
  props: {
    teamList: {
      type: Array,
    },
    idReport: {
      type: Number,
    },
    modalActive: {
      type: Boolean
    },
  },
  data: function () {
    return {
      listUserHaveTeamAndReport: [],
      listTeam: [],
      modal: false,
      report: {
        work: '',
        difficult: '',
        user_id: '',
        team_id: 1,
        experience: '',
        suggest: '',
        report_day: '2021-05-14',
      },
    }
  },
  computed: {
    API_REPORT() {
      return API_REPORT
    },
  },

  methods: {
    async getListTeam() {
      this.listTeam = await this.$axios.$get(API_TEAM)
    },

    openModalCreateReport() {
      this.modal = true
    },

    doCreateReport() {
      //form edit
      if (this.idReport) {
        this.report.team_id = Number(this.report.team_id)
        this.report.user_id = this.$auth.user.id
        this.modal = false
        this.$axios.$put(BASE_API + 'reports/' + this.idReport, this.report)
        this.$router.push('/report/')
      }

      // Form new
      else {
        this.report.team_id = Number(this.report.team_id)
        this.report.user_id = this.$auth.user.id
        this.modal = false
        this.$axios.$post(BASE_API + 'reports/', this.report)
        this.$router.push('/report/')
      }
    },

    async getReportById() {
      this.modal = true
      this.report = await this.$axios.$get(API_REPORT + this.idReport)
    },

    closeModal() {
     
      this.modal = false
       console.log("ra run close");
      this.idReport = null
    },
  },
  mounted() {
    //this.getReportById();
    //console.log(this.report);
  },
  watch: {
    idReport() {
      if (this.idReport) {
         console.log("run ne idReport ")
        this.getReportById()
        console.log(this.idReport)
        this.openModalCreateReport()
      } else {
        this.report = {}
      }
    },
    modalActive() {
      console.log("da vao modal");
      if (this.modalActive) {
        console.log("da mo modal");
        this.openModalCreateReport()
        if (this.idReport) {
          this.getReportById()
          console.log(this.idReport)
        } else {
          this.report = {}
        }
      }
    },
  },
}
</script>
<style>
.popup-report {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  padding: 4em 15em 5em 15em;
  z-index: 99;
  background-color: rgba(0, 0, 0, 0.2);
}

.btn-modal {
  margin-top: 5px;
  width: 7vw;
}

#btn-bottom button {
  width: 5vw;
}

textarea {
  height: 5vh !important;
}
</style>